setup-ipsec-vpn/vpnsetup.sh

397 lines
13 KiB
Bash
Raw Normal View History

2014-02-16 08:15:11 +01:00
#!/bin/sh
#
2015-07-14 00:46:16 +02:00
# Amazon EC2 user-data file for automatic configuration of IPsec/L2TP VPN server
2015-08-18 23:14:42 +02:00
# on a Ubuntu or Debian instance. Tested with Ubuntu 14.04 & 12.04 and Debian 8.
2014-08-14 20:02:24 +02:00
# With minor modifications, this script *can also be used* on dedicated servers
# or any KVM- or XEN-based Virtual Private Server (VPS) from other providers.
2014-02-16 08:15:11 +01:00
#
2014-10-08 23:05:20 +02:00
# DO NOT RUN THIS SCRIPT ON YOUR PC OR MAC! THIS IS MEANT TO BE RUN WHEN
# YOUR AMAZON EC2 INSTANCE STARTS!
#
2014-02-16 10:56:38 +01:00
# Copyright (C) 2014 Lin Song
# Based on the work of Thomas Sarlandie (Copyright 2012)
#
2014-02-16 08:15:11 +01:00
# This work is licensed under the Creative Commons Attribution-ShareAlike 3.0
# Unported License: http://creativecommons.org/licenses/by-sa/3.0/
#
# Attribution required: please include my name in any derivative and let me
# know how you have improved it!
2014-12-13 06:13:20 +01:00
if [ "$(uname)" = "Darwin" ]; then
2015-07-03 18:33:00 +02:00
echo 'DO NOT run this script on your Mac! It should only be run on a newly-created EC2 instance'
echo 'or other Dedicated Server / VPS, after you have modified it to set the variables below.'
2015-08-18 23:14:42 +02:00
exit 1
2015-07-03 18:33:00 +02:00
fi
# Please define your own values for these variables
# Escape *all* non-alphanumeric characters with a backslash (or 3 backslashes for \ and ").
# Examples: \ --> \\\\, " --> \\\", ' --> \', $ --> \$, ` --> \`, [space] --> \[space]
2014-02-16 08:15:11 +01:00
IPSEC_PSK=your_very_secure_key
VPN_USER=your_username
VPN_PASSWORD=your_very_secure_password
2016-01-17 22:39:08 +01:00
# IMPORTANT: Be sure to read important notes at the URL below:
# https://github.com/hwdsl2/setup-ipsec-vpn#important-notes
2015-08-18 23:14:42 +02:00
2016-01-18 03:17:18 +01:00
if [ "$(lsb_release -si 2>/dev/null)" != "Ubuntu" ] && [ "$(lsb_release -si 2>/dev/null)" != "Debian" ]; then
echo "Looks like you aren't running this script on a Ubuntu or Debian system."
exit 1
fi
if [ -f "/proc/user_beancounters" ]; then
2016-01-19 08:23:17 +01:00
echo "This script does NOT support OpenVZ VPS."
echo "Try Nyr's OpenVPN script instead: https://github.com/Nyr/openvpn-install"
exit 1
fi
if [ "$(id -u)" != 0 ]; then
echo "Sorry, you need to run this script as root."
exit 1
fi
# Check for empty VPN variables
2016-01-17 22:39:08 +01:00
if [ -z "$IPSEC_PSK" ] || [ -z "$VPN_USER" ] || [ -z "$VPN_PASSWORD" ]; then
2016-01-19 08:23:17 +01:00
echo "The VPN credentials cannot be empty. Please re-edit the VPN script."
2016-01-17 22:39:08 +01:00
exit 1
fi
# Create and change to working dir
mkdir -p /opt/src
cd /opt/src || { echo "Failed to change working directory to /opt/src. Aborting."; exit 1; }
# Update package index and install wget, dig (dnsutils), sed and nano
2015-08-18 23:14:42 +02:00
export DEBIAN_FRONTEND=noninteractive
2015-07-03 18:33:00 +02:00
apt-get -y update
apt-get -y install wget dnsutils sed nano
2015-07-03 18:33:00 +02:00
echo
2016-01-17 22:39:08 +01:00
echo 'Please wait... Trying to find Public/Private IP of this server.'
echo
echo 'If the script hangs here for more than a few minutes, press Ctrl-C to interrupt,'
2016-01-17 22:39:08 +01:00
echo 'then edit and comment out the next two lines PUBLIC_IP= and PRIVATE_IP=, or replace'
echo 'them with actual IPs. If your server only has a public IP, put it on both lines.'
echo
2015-07-03 18:33:00 +02:00
2015-08-18 23:14:42 +02:00
# In Amazon EC2, these two variables will be found automatically.
2015-07-03 18:33:00 +02:00
# For all other servers, you may replace them with the actual IPs,
2015-08-18 23:14:42 +02:00
# or comment out and let the script auto-detect in the next section.
2016-01-17 22:39:08 +01:00
# If your server only has a public IP, put it on both lines.
2015-08-18 23:14:42 +02:00
PUBLIC_IP=$(wget --retry-connrefused -t 3 -T 15 -qO- 'http://169.254.169.254/latest/meta-data/public-ipv4')
PRIVATE_IP=$(wget --retry-connrefused -t 3 -T 15 -qO- 'http://169.254.169.254/latest/meta-data/local-ipv4')
2015-07-03 18:33:00 +02:00
2016-01-17 22:39:08 +01:00
# Attempt to find server IPs for non-EC2 servers
[ -z "$PUBLIC_IP" ] && PUBLIC_IP=$(dig +short myip.opendns.com @resolver1.opendns.com)
[ -z "$PUBLIC_IP" ] && PUBLIC_IP=$(wget -t 3 -T 15 -qO- http://ipv4.icanhazip.com)
[ -z "$PUBLIC_IP" ] && PUBLIC_IP=$(wget -t 3 -T 15 -qO- http://ipecho.net/plain)
[ -z "$PRIVATE_IP" ] && PRIVATE_IP=$(ip -4 route get 1 | awk '{print $NF;exit}')
[ -z "$PRIVATE_IP" ] && PRIVATE_IP=$(ifconfig eth0 | grep -Eo 'inet (addr:)?([0-9]*\.){3}[0-9]*' | grep -Eo '([0-9]*\.){3}[0-9]*')
2014-12-13 07:49:18 +01:00
2016-01-17 22:39:08 +01:00
# Check IPs for correct format
IP_REGEX="^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$"
if printf %s "$PUBLIC_IP" | grep -vEq "$IP_REGEX"; then
echo "Could not find valid Public IP, please edit the VPN script manually."
exit 1
fi
if printf %s "$PRIVATE_IP" | grep -vEq "$IP_REGEX"; then
echo "Could not find valid Private IP, please edit the VPN script manually."
exit 1
fi
2014-02-16 08:15:11 +01:00
# Install necessary packages
2015-07-03 18:33:00 +02:00
apt-get -y install libnss3-dev libnspr4-dev pkg-config libpam0g-dev \
2014-02-16 08:15:11 +01:00
libcap-ng-dev libcap-ng-utils libselinux1-dev \
libcurl4-nss-dev libgmp3-dev flex bison gcc make \
2015-08-18 23:14:42 +02:00
libunbound-dev libnss3-tools libevent-dev
apt-get -y --no-install-recommends install xmlto
2015-07-03 18:33:00 +02:00
apt-get -y install xl2tpd
2014-02-16 08:15:11 +01:00
# Install Fail2Ban to protect SSH server
apt-get -y install fail2ban
2014-09-19 00:58:19 +02:00
# Compile and install Libreswan (https://libreswan.org/)
2015-08-18 23:14:42 +02:00
SWAN_VER=3.16
SWAN_FILE="libreswan-${SWAN_VER}.tar.gz"
SWAN_URL="https://download.libreswan.org/${SWAN_FILE}"
wget -t 3 -T 30 -nv -O "$SWAN_FILE" "$SWAN_URL"
[ ! -f "$SWAN_FILE" ] && { echo "Could not retrieve Libreswan source file. Aborting."; exit 1; }
/bin/rm -rf "/opt/src/libreswan-${SWAN_VER}"
tar xvzf "$SWAN_FILE" && rm -f "$SWAN_FILE"
cd "libreswan-${SWAN_VER}" || { echo "Failed to enter Libreswan source directory. Aborting."; exit 1; }
2015-07-23 19:49:02 +02:00
make programs && make install
2014-02-16 08:15:11 +01:00
# Prepare various config files
2016-01-17 22:39:08 +01:00
# Create Libreswan configuration
/bin/cp -f /etc/ipsec.conf "/etc/ipsec.conf.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
2014-02-16 08:15:11 +01:00
cat > /etc/ipsec.conf <<EOF
version 2.0
config setup
dumpdir=/var/run/pluto/
nat_traversal=yes
virtual_private=%v4:10.0.0.0/8,%v4:192.168.0.0/16,%v4:172.16.0.0/12,%v4:!192.168.42.0/24
oe=off
protostack=netkey
nhelpers=0
interfaces=%defaultroute
conn vpnpsk
connaddrfamily=ipv4
auto=add
left=$PRIVATE_IP
leftid=$PUBLIC_IP
leftsubnet=$PRIVATE_IP/32
leftnexthop=%defaultroute
leftprotoport=17/1701
rightprotoport=17/%any
right=%any
rightsubnetwithin=0.0.0.0/0
forceencaps=yes
authby=secret
pfs=no
type=transport
auth=esp
ike=3des-sha1,aes-sha1
phase2alg=3des-sha1,aes-sha1
rekey=no
keyingtries=5
dpddelay=30
dpdtimeout=120
dpdaction=clear
EOF
2016-01-17 22:39:08 +01:00
# Specify IPsec PSK
/bin/cp -f /etc/ipsec.secrets "/etc/ipsec.secrets.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
2014-02-16 08:15:11 +01:00
cat > /etc/ipsec.secrets <<EOF
$PUBLIC_IP %any : PSK "$IPSEC_PSK"
EOF
2016-01-17 22:39:08 +01:00
# Create xl2tpd config
/bin/cp -f /etc/xl2tpd/xl2tpd.conf "/etc/xl2tpd/xl2tpd.conf.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
2014-02-16 08:15:11 +01:00
cat > /etc/xl2tpd/xl2tpd.conf <<EOF
[global]
port = 1701
;debug avp = yes
;debug network = yes
;debug state = yes
;debug tunnel = yes
[lns default]
ip range = 192.168.42.10-192.168.42.250
local ip = 192.168.42.1
require chap = yes
refuse pap = yes
require authentication = yes
name = l2tpd
;ppp debug = yes
pppoptfile = /etc/ppp/options.xl2tpd
length bit = yes
EOF
2016-01-17 22:39:08 +01:00
# Specify xl2tpd options
/bin/cp -f /etc/ppp/options.xl2tpd "/etc/ppp/options.xl2tpd.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
2014-02-16 08:15:11 +01:00
cat > /etc/ppp/options.xl2tpd <<EOF
ipcp-accept-local
ipcp-accept-remote
ms-dns 8.8.8.8
ms-dns 8.8.4.4
noccp
auth
crtscts
idle 1800
mtu 1280
mru 1280
lock
lcp-echo-failure 10
lcp-echo-interval 60
connect-delay 5000
EOF
2016-01-17 22:39:08 +01:00
# Create VPN credentials
/bin/cp -f /etc/ppp/chap-secrets "/etc/ppp/chap-secrets.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
2014-02-16 08:15:11 +01:00
cat > /etc/ppp/chap-secrets <<EOF
# Secrets for authentication using CHAP
# client server secret IP addresses
"$VPN_USER" l2tpd "$VPN_PASSWORD" *
2014-02-16 08:15:11 +01:00
EOF
2016-01-17 22:39:08 +01:00
# Update sysctl settings for VPN and better performance
if ! grep -qs "hwdsl2 VPN script" /etc/sysctl.conf; then
2015-08-18 23:14:42 +02:00
/bin/cp -f /etc/sysctl.conf "/etc/sysctl.conf.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
cat >> /etc/sysctl.conf <<EOF
# Added by hwdsl2 VPN script
2014-02-16 08:15:11 +01:00
kernel.sysrq = 0
kernel.core_uses_pid = 1
kernel.msgmnb = 65536
kernel.msgmax = 65536
kernel.shmmax = 68719476736
kernel.shmall = 4294967296
kernel.randomize_va_space = 1
2014-02-16 08:15:11 +01:00
net.ipv4.ip_forward = 1
net.ipv4.tcp_syncookies = 1
2014-02-16 08:15:11 +01:00
net.ipv4.conf.all.accept_source_route = 0
net.ipv4.conf.default.accept_source_route = 0
net.ipv4.conf.all.log_martians = 1
net.ipv4.conf.default.log_martians = 1
net.ipv4.conf.all.accept_redirects = 0
net.ipv4.conf.default.accept_redirects = 0
net.ipv4.conf.all.send_redirects = 0
net.ipv4.conf.default.send_redirects = 0
net.ipv4.conf.lo.send_redirects = 0
net.ipv4.conf.eth0.send_redirects = 0
2014-02-16 08:15:11 +01:00
net.ipv4.conf.all.rp_filter = 0
net.ipv4.conf.default.rp_filter = 0
net.ipv4.conf.lo.rp_filter = 0
net.ipv4.conf.eth0.rp_filter = 0
2014-02-16 08:15:11 +01:00
net.ipv4.icmp_echo_ignore_broadcasts = 1
net.ipv4.icmp_ignore_bogus_error_responses = 1
net.core.wmem_max = 12582912
net.core.rmem_max = 12582912
net.ipv4.tcp_rmem = 10240 87380 12582912
net.ipv4.tcp_wmem = 10240 87380 12582912
2014-02-16 08:15:11 +01:00
EOF
fi
2016-01-17 22:39:08 +01:00
# Create basic IPTables rules. First, check if there are existing IPTables rules loaded.
# 1. If IPTables is "empty", write out the new set of rules below.
# 2. If *not* empty, insert new rules and save them together with existing ones.
if ! grep -qs "hwdsl2 VPN script" /etc/iptables.rules; then
2015-08-18 23:14:42 +02:00
/bin/cp -f /etc/iptables.rules "/etc/iptables.rules.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
/usr/sbin/service fail2ban stop >/dev/null 2>&1
if [ "$(/sbin/iptables-save | grep -c '^\-')" = "0" ]; then
2014-02-16 08:15:11 +01:00
cat > /etc/iptables.rules <<EOF
# Added by hwdsl2 VPN script
2014-02-16 08:15:11 +01:00
*filter
:INPUT ACCEPT [0:0]
:FORWARD ACCEPT [0:0]
:OUTPUT ACCEPT [0:0]
:ICMPALL - [0:0]
-A INPUT -m conntrack --ctstate INVALID -j DROP
-A INPUT -m conntrack --ctstate RELATED,ESTABLISHED -j ACCEPT
-A INPUT -i lo -j ACCEPT
-A INPUT -d 127.0.0.0/8 -j REJECT
2014-02-16 08:15:11 +01:00
-A INPUT -p icmp --icmp-type 255 -j ICMPALL
-A INPUT -p udp --dport 67:68 --sport 67:68 -j ACCEPT
-A INPUT -p tcp --dport 22 -j ACCEPT
-A INPUT -p udp -m multiport --dports 500,4500 -j ACCEPT
-A INPUT -p udp --dport 1701 -m policy --dir in --pol ipsec -j ACCEPT
-A INPUT -p udp --dport 1701 -j DROP
2014-12-13 05:57:35 +01:00
-A INPUT -j DROP
-A FORWARD -m conntrack --ctstate INVALID -j DROP
2014-02-16 08:15:11 +01:00
-A FORWARD -i eth+ -o ppp+ -m conntrack --ctstate RELATED,ESTABLISHED -j ACCEPT
-A FORWARD -i ppp+ -o eth+ -j ACCEPT
2015-08-18 23:14:42 +02:00
# If you wish to allow traffic between VPN clients themselves, uncomment this line:
# -A FORWARD -i ppp+ -o ppp+ -s 192.168.42.0/24 -d 192.168.42.0/24 -j ACCEPT
2014-12-13 05:57:35 +01:00
-A FORWARD -j DROP
2015-07-14 00:46:16 +02:00
-A ICMPALL -p icmp -f -j DROP
2014-02-16 08:15:11 +01:00
-A ICMPALL -p icmp --icmp-type 0 -j ACCEPT
-A ICMPALL -p icmp --icmp-type 3 -j ACCEPT
-A ICMPALL -p icmp --icmp-type 4 -j ACCEPT
-A ICMPALL -p icmp --icmp-type 8 -j ACCEPT
-A ICMPALL -p icmp --icmp-type 11 -j ACCEPT
2014-04-25 07:28:17 +02:00
-A ICMPALL -p icmp -j DROP
2014-02-16 08:15:11 +01:00
COMMIT
*nat
:PREROUTING ACCEPT [0:0]
:INPUT ACCEPT [0:0]
:OUTPUT ACCEPT [0:0]
:POSTROUTING ACCEPT [0:0]
-A POSTROUTING -s 192.168.42.0/24 -o eth+ -j SNAT --to-source "${PRIVATE_IP}"
2014-02-16 08:15:11 +01:00
COMMIT
EOF
else
iptables -I INPUT 1 -p udp -m multiport --dports 500,4500 -j ACCEPT
iptables -I INPUT 2 -p udp --dport 1701 -m policy --dir in --pol ipsec -j ACCEPT
iptables -I INPUT 3 -p udp --dport 1701 -j DROP
iptables -I FORWARD 1 -m conntrack --ctstate INVALID -j DROP
iptables -I FORWARD 2 -i eth+ -o ppp+ -m conntrack --ctstate RELATED,ESTABLISHED -j ACCEPT
iptables -I FORWARD 3 -i ppp+ -o eth+ -j ACCEPT
# iptables -I FORWARD 4 -i ppp+ -o ppp+ -s 192.168.42.0/24 -d 192.168.42.0/24 -j ACCEPT
iptables -A FORWARD -j DROP
iptables -t nat -I POSTROUTING -s 192.168.42.0/24 -o eth+ -j SNAT --to-source "${PRIVATE_IP}"
2016-01-17 22:39:08 +01:00
echo "# Modified by hwdsl2 VPN script" > /etc/iptables.rules
/sbin/iptables-save >> /etc/iptables.rules
fi
fi
2016-01-17 22:39:08 +01:00
# Create basic IP6Tables rules
if ! grep -qs "hwdsl2 VPN script" /etc/ip6tables.rules; then
/bin/cp -f /etc/ip6tables.rules "/etc/ip6tables.rules.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
cat > /etc/ip6tables.rules <<EOF
# Added by hwdsl2 VPN script
*filter
:INPUT ACCEPT [0:0]
:FORWARD DROP [0:0]
:OUTPUT ACCEPT [0:0]
-A INPUT -i lo -j ACCEPT
-A INPUT -m state --state ESTABLISHED,RELATED -j ACCEPT
-A INPUT -m rt --rt-type 0 -j DROP
-A INPUT -s fe80::/10 -j ACCEPT
-A INPUT -p ipv6-icmp -j ACCEPT
-A INPUT -j DROP
COMMIT
EOF
fi
2016-01-17 22:39:08 +01:00
# Load IPTables rules at system boot
2014-02-16 08:15:11 +01:00
cat > /etc/network/if-pre-up.d/iptablesload <<EOF
#!/bin/sh
/sbin/iptables-restore < /etc/iptables.rules
exit 0
EOF
cat > /etc/network/if-pre-up.d/ip6tablesload <<EOF
#!/bin/sh
/sbin/ip6tables-restore < /etc/ip6tables.rules
exit 0
EOF
2016-01-17 22:39:08 +01:00
# Update rc.local to start services at system boot
if ! grep -qs "hwdsl2 VPN script" /etc/rc.local; then
2015-08-18 23:14:42 +02:00
/bin/cp -f /etc/rc.local "/etc/rc.local.old-$(date +%Y-%m-%d-%H:%M:%S)" 2>/dev/null
/bin/sed --follow-symlinks -i -e '/^exit 0/d' /etc/rc.local
cat >> /etc/rc.local <<EOF
# Added by hwdsl2 VPN script
/usr/sbin/service fail2ban restart || /bin/true
/usr/sbin/service ipsec start
/usr/sbin/service xl2tpd start
2014-03-25 10:52:38 +01:00
echo 1 > /proc/sys/net/ipv4/ip_forward
2014-02-16 08:15:11 +01:00
exit 0
EOF
fi
2016-01-17 22:39:08 +01:00
# Initialize Libreswan database
2014-02-16 08:15:11 +01:00
if [ ! -f /etc/ipsec.d/cert8.db ] ; then
echo > /var/tmp/libreswan-nss-pwd
/usr/bin/certutil -N -f /var/tmp/libreswan-nss-pwd -d /etc/ipsec.d
/bin/rm -f /var/tmp/libreswan-nss-pwd
fi
2016-01-17 22:39:08 +01:00
# Reload sysctl.conf settings
2014-02-16 08:15:11 +01:00
/sbin/sysctl -p
2016-01-17 22:39:08 +01:00
# Update attributes of various files
/bin/chmod +x /etc/rc.local
2014-02-16 08:15:11 +01:00
/bin/chmod +x /etc/network/if-pre-up.d/iptablesload
/bin/chmod +x /etc/network/if-pre-up.d/ip6tablesload
/bin/chmod 600 /etc/ipsec.secrets* /etc/ppp/chap-secrets*
2016-01-17 22:39:08 +01:00
# Apply new IPTables rules
2014-02-16 08:15:11 +01:00
/sbin/iptables-restore < /etc/iptables.rules
/sbin/ip6tables-restore < /etc/ip6tables.rules
2014-02-16 08:15:11 +01:00
2016-01-17 22:39:08 +01:00
# Restart services
/usr/sbin/service fail2ban stop >/dev/null 2>&1
/usr/sbin/service ipsec stop >/dev/null 2>&1
/usr/sbin/service xl2tpd stop >/dev/null 2>&1
/usr/sbin/service fail2ban start
/usr/sbin/service ipsec start
/usr/sbin/service xl2tpd start